/* Copyright © 2020 tyrolyean
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include "sound.h"
#include "sound.h"
#include "dac.h"

#include <avr/pgmspace.h>
#include <stddef.h>

const struct tone_t computer_room_track[] PROGMEM =
{
	{DAC_MODE_SQUARE,  0,100},
	{DAC_MODE_SQUARE,  10,100},
	{DAC_MODE_SQUARE,  0,100},
	{DAC_MODE_SQUARE,  10,100},
	{DAC_MODE_SQUARE,  0,100},
	{DAC_MODE_NOISE,   0,200},
	{DAC_MODE_SINE,    10,50},
	{DAC_MODE_SINE,    -10,50},
	{DAC_MODE_SINE,    10,50},
	{DAC_MODE_SINE,    -10,50},
	
	{DAC_MODE_SQUARE,  0,100},
	{DAC_MODE_SQUARE,  10,100},
	{DAC_MODE_SQUARE,  0,100},
	{DAC_MODE_SQUARE,  10,100},
	{DAC_MODE_SQUARE,  0,100},
	{DAC_MODE_NOISE,   0,200},
	{DAC_MODE_SINE,    10,50},
	{DAC_MODE_SINE,    -10,50},
	{DAC_MODE_SINE,    10,50},
	{DAC_MODE_SINE,    -10,50},
	
	{DAC_MODE_SQUARE,  0,100},
	{DAC_MODE_SQUARE,  10,100},
	{DAC_MODE_SQUARE,  0,100},
	{DAC_MODE_SQUARE,  10,100},
	{DAC_MODE_SQUARE,  0,100},
	{DAC_MODE_NOISE,   0,200},
	{DAC_MODE_SINE,    10,50},
	{DAC_MODE_SINE,    -10,50},
	{DAC_MODE_SINE,    10,50},
	{DAC_MODE_SINE,    -10,50},

	{DAC_MODE_SQUARE,  0,100},
	{DAC_MODE_SQUARE,  10,100},
	{DAC_MODE_SQUARE,  0,100},
	{DAC_MODE_SQUARE,  10,100},
	{DAC_MODE_SQUARE,  0,100},
	{DAC_MODE_NOISE,   0,200},
	{DAC_MODE_SINE,    10,50},
	{DAC_MODE_SINE,    -10,50},
	{DAC_MODE_SINE,    10,50},
	{DAC_MODE_SINE,    -10,50},

	{DAC_MODE_SQUARE,  0,100},
	{DAC_MODE_SQUARE,  10,100},
	{DAC_MODE_SQUARE,  0,100},
	{DAC_MODE_SQUARE,  10,100},
	{DAC_MODE_SQUARE,  0,100},
	{DAC_MODE_NOISE,   0,200},
	{DAC_MODE_SINE,    10,50},
	{DAC_MODE_SINE,    -10,50},
	{DAC_MODE_SINE,    10,50},
	{DAC_MODE_SINE,    -10,50},
	
	{DAC_MODE_SQUARE,  -2,100},
	{DAC_MODE_SQUARE,  8,100},
	{DAC_MODE_SQUARE,  -2,100},
	{DAC_MODE_SQUARE,  8,100},
	{DAC_MODE_SQUARE,  -2,100},
	{DAC_MODE_NOISE,   0,200},
	{DAC_MODE_SINE,    12,50},
	{DAC_MODE_SINE,    -8,50},
	{DAC_MODE_SINE,    12,50},
	{DAC_MODE_SINE,    -8,50},
	
	{DAC_MODE_SQUARE,  -3,100},
	{DAC_MODE_SQUARE,  7,100},
	{DAC_MODE_SQUARE,  -3,100},
	{DAC_MODE_SQUARE,  7,100},
	{DAC_MODE_SQUARE,  -3,100},
	{DAC_MODE_NOISE,   0,200},
	{DAC_MODE_SINE,    13,50},
	{DAC_MODE_SINE,    -7,50},
	{DAC_MODE_SINE,    13,50},
	{DAC_MODE_SINE,    -7,50},

	TRACK_END_MARKER
};

const struct tone_t lonely_road_track[] PROGMEM =
{	

	{DAC_MODE_SQUARE,   -2,80},
	{DAC_MODE_SQUARE,  -3,80},
	{DAC_MODE_SAW,  -4,170},
	{DAC_MODE_SILENT,   0,30},
	{DAC_MODE_SAW,  -6,170},
	{DAC_MODE_SILENT,   0,30},
	{DAC_MODE_SAW,  -6,170},
	{DAC_MODE_SILENT,   0,30},
	
	{DAC_MODE_SQUARE,   -2,80},
	{DAC_MODE_SQUARE,  -3,80},
	{DAC_MODE_SAW,  -4,170},
	{DAC_MODE_SILENT,   0,30},
	{DAC_MODE_SAW,  -6,170},
	{DAC_MODE_SILENT,   0,30},
	{DAC_MODE_SAW,  -6,170},
	{DAC_MODE_SILENT,   0,30},
	
	{DAC_MODE_SQUARE,   -2,80},
	{DAC_MODE_SQUARE,  -3,80},
	{DAC_MODE_SAW,  -4,170},
	{DAC_MODE_SILENT,   0,30},
	{DAC_MODE_SAW,  -6,170},
	{DAC_MODE_SILENT,   0,30},
	{DAC_MODE_SAW,  -6,300},
	{DAC_MODE_SAW,  -4,130},
	{DAC_MODE_SAW,  -2,130},
	{DAC_MODE_SILENT,   0,80},
	

	{DAC_MODE_SQUARE,   -1,80},
	{DAC_MODE_SQUARE,  -2,80},
	{DAC_MODE_SAW,  -3,170},
	{DAC_MODE_SILENT,   0,20},
	{DAC_MODE_SAW,  -5,170},
	{DAC_MODE_SILENT,   0,20},
	{DAC_MODE_SAW,  -5,170},
	{DAC_MODE_SILENT,   0,30},

	{DAC_MODE_SQUARE,   -1,80},
	{DAC_MODE_SQUARE,  -2,80},
	{DAC_MODE_SAW,  -3,170},
	{DAC_MODE_SILENT,   0,20},
	{DAC_MODE_SAW,  -5,170},
	{DAC_MODE_SILENT,   0,20},
	{DAC_MODE_SAW,  -5,170},
	{DAC_MODE_SILENT,   0,20},
	
	{DAC_MODE_SQUARE,  -1,80},
	{DAC_MODE_SQUARE,  -2,80},
	{DAC_MODE_SAW,     -3,170},
	{DAC_MODE_SILENT,   0,30},
	{DAC_MODE_SAW,     -5,170},
	{DAC_MODE_SILENT,   0,30},
	{DAC_MODE_SAW,  -5,300},
	{DAC_MODE_SAW,  -3,130},
	{DAC_MODE_SAW,  -1,130},
	{DAC_MODE_SILENT,   0,80},
	TRACK_END_MARKER
};

const struct tone_t intro_track[] PROGMEM =
{
	{DAC_MODE_SQUARE,  -3,200},
	{DAC_MODE_SQUARE,  -4,200},
	{DAC_MODE_SQUARE,  -5,200},
	{DAC_MODE_SQUARE,  -3,200},
	{DAC_MODE_SQUARE,  -4,200},
	{DAC_MODE_SQUARE,  -5,200},
	{DAC_MODE_SQUARE,  -3,200},
	{DAC_MODE_SQUARE,  -4,200},
	{DAC_MODE_SQUARE,  -5,200},
	{DAC_MODE_SQUARE,  -3,200},
	{DAC_MODE_SQUARE,  -4,200},
	{DAC_MODE_SQUARE,  -5,200},
	

	{DAC_MODE_SQUARE,  -3,200},
	{DAC_MODE_SQUARE,  -4,200},
	{DAC_MODE_SQUARE,  -5,200},
	{DAC_MODE_SQUARE,  -3,200},
	{DAC_MODE_SQUARE,  -4,200},
	{DAC_MODE_SQUARE,  -5,200},
	{DAC_MODE_SQUARE,  -3,200},
	{DAC_MODE_SQUARE,  -4,200},
	{DAC_MODE_SQUARE,  -5,200},
	{DAC_MODE_SQUARE,  -3,200},
	{DAC_MODE_SQUARE,  -4,200},
	{DAC_MODE_SQUARE,  -5,200},
	
	{DAC_MODE_SQUARE,  -3,400},
	{DAC_MODE_SQUARE,  -4,400},
	{DAC_MODE_SQUARE,  -5,400},
	{DAC_MODE_SQUARE,  -3,500},
	{DAC_MODE_SQUARE,  -4,550},
	{DAC_MODE_SQUARE,  -5,600},
	
	{DAC_MODE_SQUARE,  -3,800},
	{DAC_MODE_SQUARE,  -4,900},
	{DAC_MODE_SQUARE,  -5,1000},

	{DAC_MODE_SILENT,   0,1000},
	
	TRACK_END_MARKER
};

const struct tone_t *current_track = NULL;
int16_t global_frequency_offset = 0x00;

/* Loops a track indefinitely and changes voices according to predefined tables.
 * A new track resets the internal state. A voice with a length of 0ms is used
 * to mark the end of a track and continue at the beginning
 */
void update_sound(){
	
	static uint16_t audio_time = 0;
	static size_t tone_pointer = 0x00;
	static struct tone_t current_tone = {DAC_MODE_SILENT, 0,0};
	if(current_track == NULL){
		/* ABORT */
		audio_time = 0x00;
		return;
	}
	audio_time++;
	static const struct tone_t * old_track = NULL;
	
	if(audio_time >= current_tone.length || 
		current_track != old_track){
		
		if(old_track != current_track){
			tone_pointer = 0;
			audio_time = 0x00;
			old_track = current_track;
		}
		memcpy_P(&current_tone,&(current_track[tone_pointer]), 
			sizeof(current_tone));
		
		if(current_tone.length == 0){
			tone_pointer = 0;
			memcpy_P(&current_tone,&(current_track[tone_pointer]), 
				sizeof(current_tone));

		}

		dac_mode = current_tone.waveform;
		dac_frequency_deviation = current_tone.frequency_deviation + 
			global_frequency_offset;
		audio_time = 0x00;
		tone_pointer++;
	}
	return;
}
